//=============================================================
// Root Macro to check the format within this tree
//=============================================================
#ifndef __CINT__
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <iostream>
using namespace std;

int CheckSignalTree();

#include "../include/CintIncludes.h"
#include "TNT2Event.h"

//______________________________________________________________________
int main()
{
  int n = CheckSignalTree();
  return n;
}
#endif

int CheckFakeTree()
{
  Int_t readDict     = 1;

  //this causes a crash when reading the tree....
  if(readDict) {
#ifdef __CINT__
    if (!TClassTable::GetDict("Signal")) {
      cout << "reading in library definition" << endl;
      gSystem->Load("./libTNT2Event.so");
    }
#endif
    
    TFile *f = TFile::Open("FakeEvent.root");
    f->ls();
    
    TTree *testT0  = (TTree*) f->Get("testTree1");
    testT0->Print();

    //This Tree contains :
    TBranch *bfEventNumber; // A branch for the event counter
    TBranch *bfTimeStamp;   // A branch for the time stamp
    TBranch *bSignals;      // A branch for the Signals TClonesArray
    TClonesArray* sigArray;       //   which contains
    TBranch *bfTriggerCounter;   //      a branch for the trigger counter
    TBranch *bfNSamples;         //      a redundent branch containing the number of samples
    TBranch *bfSamples  ;        //      a branch for the Samples TClonesArray
    TClonesArray *signals_array; //         which contain the SamplePoints
    
    Signal*       thisSignal;
    SamplePoint* thisSample;
    
    //this must be before I use GetEntries !
    bSignals = testT0->GetBranch("sBranch");
    bSignals->SetAddress(&sigArray);

    cout << "got here" << endl;
    
    Int_t nEntries = (Int_t)testT0->GetEntries();
    cout << " has " << nEntries << " entries" << endl;


    //TObject
    for(Int_t i = 0; i < 3; i++)
      testT0->Show(i);

    //my Print() functionality
    for(Int_t i = 0; i < 5; i++) {
      cout << "entry " << i << endl;
      
      testT0->GetEntry(i);
      for(Int_t s = 0; s <= sigArray->GetLast(); s++) {
	thisSignal = (Signal *) sigArray->At(s);
	thisSignal->Print();
      }
    }
    
    return 0;

    //Totally by hand
    bfEventNumber = testT0->GetBranch("fEventNumber");
    ULong64_t thisEventNumber;
    bfEventNumber->SetAddress(&thisEventNumber);

    bfTimeStamp = testT0->GetBranch("fTimeStamp");
    ULong64_t thisTimeStamp;
    bfTimeStamp->SetAddress(&thisTimeStamp);

    
    for(Int_t i = 0; i < 5; i++) {
      testT0->GetEntry(i);
      cout << "Event number " << thisEventNumber << endl;
      cout << "\t TimeStamp " << thisTimeStamp << endl;

      for(Int_t s = 0; s <= sigArray->GetLast(); s++) {
      
	thisSignal = (Signal *) sigArray->At(s);
	cout << "\t Signal " << s << endl;
	cout << "\t\t " << thisSignal->fTriggerCounter <<  "  " << thisSignal->fNSamples <<endl;

	samples_array = thisSignal->GetArray();
	Int_t nSamples = samples_array->GetLast() + 1;
	cout << "\t\t\t";
	for(Int_t sp = 0; sp < 10 && sp < nSamples; sp++) {
	  //thisSample = (SamplePoint*) samples_array->At(sp);
	  Short_t thisPoint = ((SamplePoint*) samples_array->At(sp))->GetSamplePoint();
	  cout << thisPoint << ",";
	}
	cout << endl;
      }
    }
  }
  return 1;
}
