//=============================================================
// Root Macro to check the format within this tree
//=============================================================
#ifndef __CINT__
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <iostream>
using namespace std;

int CheckSignalTree();

#include "../include/CintIncludes.h"
#include "TNT2Event.h"

//______________________________________________________________________
int main()
{
  int n = CheckSignalTree();
  return n;
}
#endif

int CheckSignalTree()
{
  Int_t readDict     = 1;
  Int_t showBusErorr = 1;

  //this causes a crash when reading the tree....
  if(readDict) {
#ifdef __CINT__
    if (!TClassTable::GetDict("Signal")) {
      cout << "reading in library definition" << endl;
      gSystem->Load("./libTNT2Event.so");
    }
#endif
    
    TFile *f = TFile::Open("TestSignalTree.root");
    f->ls();
    
    TTree *testT0  = (TTree*) f->Get("testTree0");
    testT0->Print();

    TBranch *Sbranch;          //Super branch : A Signal which contains
    TBranch *bfTriggerCounter; //    a branch for the trigger counter
    TBranch *bfNSamples;       //    a redundent branch containing the number of samples
    TBranch *bfSamples  ;      //    a branch for the Samples TClonesArray
    TClonesArray *samples_array; //    which merely contains a sample point

    SamplePoint* thisSample;

    //this must be before I use GetEntries !
    Sbranch = testT0->GetBranch("sigBranch");

    cout << "got here" << endl;
    
    Int_t nEntries = (Int_t)testT0->GetEntries();
    cout << " has " << nEntries << " entries" << endl;
    
    if(showBusErorr) {
      for(Int_t i = 0; i < 3; i++) {
	testT0->Show(i);
      }
    }

    gObjectTable->Print();

    //=================================
    //object for the signals : 
    Signal* signal = new Signal();
    Sbranch->SetAddress(&signal);

    gObjectTable->Print();
    
    for(Int_t i = 0; i < 5; i++) {
      cout << "entry " << i << endl;
      
      testT0->GetEntry(i);
      //signal->Print();
    }
    
    gObjectTable->Print();
    delete signal;
    gObjectTable->Print();


    //=================================
    //object for the signals : 
    Signal* signal2;
    signal2 = new Signal();
    //reset to to make sure
    Sbranch = testT0->GetBranch("sigBranch");
    Sbranch->SetAddress(&signal2);
    
    for(Int_t i = 0; i < 5; i++) {
      cout << "entry " << i << endl;
      signal2->Clear();
      
      testT0->GetEntry(i);
      //in order to use Print() here there should not ne a "delete" in Print
      signal2->Print();

      cout << signal2->fTriggerCounter << endl;

      samples_array  = signal2->GetArray();
      Int_t nSamples = samples_array->GetLast() + 1;
      cout << "\t " << nSamples << " cf " <<  signal2->fNSamples << endl;

      for(Int_t s = 0; s < 10 && s < nSamples; s++) {
	thisSample = (SamplePoint*) samples_array->At(s);
	thisSample->Print();
      }


      for(Int_t s = 0; s < 10 && s < nSamples; s++) {
	//thisSample = (SamplePoint*) samples_array->At(s);
	Short_t thisPoint = ((SamplePoint*) samples_array->At(s))->GetSamplePoint();
	cout << thisPoint << ",";
      }
      cout << endl;
    }

  }
  return 1;
}
